Attribute VB_Name = "OPOSConstants"
Option Explicit


'/////////////////////////////////////////////////////////////////////
'// OPOS "ResultCode" Property Constants
'/////////////////////////////////////////////////////////////////////

Public Const OPOS_SUCCESS         As Long = 0
Public Const OPOS_E_CLOSED        As Long = 101
Public Const OPOS_E_CLAIMED       As Long = 102
Public Const OPOS_E_NOTCLAIMED    As Long = 103
Public Const OPOS_E_NOSERVICE     As Long = 104
Public Const OPOS_E_DISABLED      As Long = 105
Public Const OPOS_E_ILLEGAL       As Long = 106
Public Const OPOS_E_NOHARDWARE    As Long = 107
Public Const OPOS_E_OFFLINE       As Long = 108
Public Const OPOS_E_NOEXIST       As Long = 109
Public Const OPOS_E_EXISTS        As Long = 110
Public Const OPOS_E_FAILURE       As Long = 111
Public Const OPOS_E_TIMEOUT       As Long = 112
Public Const OPOS_E_BUSY          As Long = 113
Public Const OPOS_E_EXTENDED      As Long = 114
Public Const OPOS_E_DEPRECATED    As Long = 115 ' (added in 1.11)

Public Const OPOSERR    As Long = 100 ' Base for ResultCode errors.
Public Const OPOSERREXT As Long = 200 ' Base for ResultCodeExtendedErrors.



' The following can be returned by the service object if it
' returns a failure status from its open call.
Public Const OPOS_ORS_NOPORT      As Long = 401
' Port access required at open, but configured port
' is invalid or inaccessible.
Public Const OPOS_ORS_NOTSUPPORTED As Long = 402
' Service Object does not support the specified device.
Public Const OPOS_ORS_CONFIG      As Long = 403
' Configuration information error.
Public Const OPOS_ORS_SPECIFIC    As Long = 450
' Errors greater than this value are SO-specific.


'/////////////////////////////////////////////////////////////////////
'// "ResultCodeExtended" Property Constants
'/////////////////////////////////////////////////////////////////////

Public Const OPOS_EFPTR_COVER_OPEN As Long = 201
Public Const OPOS_EFPTR_JRN_EMPTY As Long = 202
Public Const OPOS_EFPTR_REC_EMPTY As Long = 203
Public Const OPOS_EFPTR_SLP_EMPTY As Long = 204
Public Const OPOS_EFPTR_SLP_FORM As Long = 205
Public Const OPOS_EFPTR_MISSING_DEVICES As Long = 206
Public Const OPOS_EFPTR_WRONG_STATE As Long = 207
Public Const OPOS_EFPTR_TECHNICAL_ASSISTANCE As Long = 208
Public Const OPOS_EFPTR_CLOCK_ERROR As Long = 209
Public Const OPOS_EFPTR_FISCAL_MEMORY_FULL As Long = 210
Public Const OPOS_EFPTR_FISCAL_MEMORY_DISCONNECTED As Long = 211
Public Const OPOS_EFPTR_FISCAL_TOTALS_ERROR As Long = 212
Public Const OPOS_EFPTR_BAD_ITEM_QUANTITY As Long = 213
Public Const OPOS_EFPTR_BAD_ITEM_AMOUNT As Long = 214
Public Const OPOS_EFPTR_BAD_ITEM_DESCRIPTION As Long = 215
Public Const OPOS_EFPTR_RECEIPT_TOTAL_OVERFLOW As Long = 216
Public Const OPOS_EFPTR_BAD_VAT As Long = 217
Public Const OPOS_EFPTR_BAD_PRICE As Long = 218
Public Const OPOS_EFPTR_BAD_DATE As Long = 219
Public Const OPOS_EFPTR_NEGATIVE_TOTAL As Long = 220
Public Const OPOS_EFPTR_WORD_NOT_ALLOWED As Long = 221
Public Const OPOS_EFPTR_BAD_LENGTH As Long = 222
Public Const OPOS_EFPTR_MISSING_SET_CURRENCY As Long = 223
Public Const OPOS_EFPTR_DAY_END_REQUIRED As Long = 224 ' (added in 1.11)

'////////////////////////////////////////////////////////////////////''
'// "ErrorState", "PrinterState" Property Constants
'/////////////////////////////////////////////////////////////////////

Public Const FPTR_PS_MONITOR As Long = 1
Public Const FPTR_PS_FISCAL_RECEIPT As Long = 2
Public Const FPTR_PS_FISCAL_RECEIPT_TOTAL As Long = 3
Public Const FPTR_PS_FISCAL_RECEIPT_ENDING As Long = 4
Public Const FPTR_PS_FISCAL_DOCUMENT As Long = 5
Public Const FPTR_PS_FIXED_OUTPUT As Long = 6
Public Const FPTR_PS_ITEM_LIST As Long = 7
Public Const FPTR_PS_LOCKED As Long = 8
Public Const FPTR_PS_NONFISCAL As Long = 9
Public Const FPTR_PS_REPORT As Long = 10

'/////////////////////////////////////////////////////////////////////
'// Fiscal Printer Station Constants
'/////////////////////////////////////////////////////////////////////

Public Const FPTR_S_JOURNAL                   As Long = 1
Public Const FPTR_S_RECEIPT                   As Long = 2
Public Const FPTR_S_SLIP                      As Long = 4
Public Const FPTR_S_JOURNAL_RECEIPT           As Long = 3

'/////////////////////////////////////////////////////////////////////
'// "ReportType" argument in "PrintReport" method
'/////////////////////////////////////////////////////////////////////

Public Const FPTR_RT_ORDINAL                  As Long = 1
Public Const FPTR_RT_DATE                     As Long = 2
Public Const FPTR_RT_EOD_ORDINAL              As Long = 3  '(added in 1.11)

'/////////////////////////////////////////////////////////////////////
'// "FiscalReceiptType" Property Constants
'/////////////////////////////////////////////////////////////////////

Public Const FPTR_RT_CASH_IN                 As Long = 1
Public Const FPTR_RT_CASH_OUT                As Long = 2
Public Const FPTR_RT_GENERIC                 As Long = 3
Public Const FPTR_RT_SALES                   As Long = 4
Public Const FPTR_RT_SERVICE                 As Long = 5
Public Const FPTR_RT_SIMPLE_INVOICE          As Long = 6
Public Const FPTR_RT_REFUND                  As Long = 7  ' (added in 1.11)


